<template>
  <div layout="builder films" class="bfv__container">
    <div class="bfv__body">
      <h1>{{ $t('app.title') }}</h1>
      <div class="bfv__actionbar">
        <button v-if="showBuildDb" class="bfv__btn" :disabled="isBuilding" @click="buildFilmDb">
          <font-awesome-icon v-show="isBuilding" icon="spinner" spin />
          {{ $t('app.builder.build_films') }}
        </button>
        <button v-if="showDeleteDb" class="bfv__btn" :disabled="isDeletingDb" @click="deleteFilmDb">
          <font-awesome-icon v-show="isDeletingDb" icon="spinner" spin />
          {{ $t('app.builder.delete_films') }}
        </button>
        <router-link v-if="showGotoDashboard" class="bfv__link" to="/dashboard">
          {{ $t('app.builder.dashboard') }}
        </router-link>
      </div>
    </div>
  </div>
</template>

<script>
import PouchDB from 'pouchdb';

export default {
  name: 'BuilderLayout',
  data() {
    return {
      isBuilding: false,
      showDeleteDb: false,
      showBuildDb: true,
      isDeletingDb: false,
      showGotoDashboard: false,
      db: null,
    };
  },
  mounted() {
    this.db = new PouchDB('films');
    if (this.$route.query.delete) {
      this.showDeleteDb = true;
      this.showBuildDb = false;
      this.showGotoDashboard = true;
    } else {
      this.db.info().then(info => {
        if (info.doc_count > 0) {
          this.$router.push('/dashboard');
        }
      });
    }
  },
  destroyed() {
    this.db.close();
  },
  methods: {
    deleteFilmDb() {
      this.db.destroy().then(() => {
        this.db = new PouchDB('films');
        this.showDeleteDb = false;
        this.showBuildDb = true;
        this.showGotoDashboard = false;
      }).catch(err => {
        console.error(err);
      });
    },
    buildFilmDb() {
      this.isBuilding = true;
      window.ipcRenderer.invoke('update:films:db').then(films => {
        this.isBuilding = false;
        if (films.length) {
          this.db
            .bulkDocs(films.filter(Boolean))
            .then(() => this.$router.push('/dashboard'))
            // eslint-disable-next-line no-debugger
            .catch(error => console.error(error));
        }
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.bfv__container {
  width: 100%;
  height: 100%;
  background-image: url('../../assets/background-title.jpeg');
  background-repeat: no-repeat;
  background-size: cover;
}

.bfv__body {
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: flex-end;
  align-items: flex-start;
  color: white;
  h1 {
    font-size: 10rem;
    height: min-content;
    margin: 0;
  }
}
.bfv__btn {
  font-size: 3rem;
  background: #ffffffe6;
  color: #3382e8;
  border: 0;
  border-radius: 25px;
  padding: 0.3rem;
  padding-right: 0.3rem;
  padding-left: 0.3rem;
  padding-left: 1rem;
  padding-right: 1rem;
  margin-left: .5rem;
  margin-bottom: .5rem;
}

.bfv__link {
  font-size: 3rem;
  background: #ffffffe6;
  color: #3382e8;
  border: 0;
  border-radius: 25px;
  padding: 0.3rem;
  padding-right: 0.3rem;
  padding-left: 0.3rem;
  padding-left: 1rem;
  padding-right: 1rem;
  margin-left: .5rem;
  margin-bottom: .5rem;
  text-decoration: none;
}
</style>
